mod Ex11

incl Mtex

incl Mtexpl

loc rem 
  \para \bf  11. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 29.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane vyrokovej logike. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Propositional Logic.  \end 

rem 
  \para \bf  Subsection. Arithmetization of Propositional Formulas.  \end 

rem 
  \para \bf  Constructors of propositional formulas.  \end 

fun/0 Tc 'Tex_f0_pl_tc'
  Tc = 0,0

fun/0 Fc 'Tex_f0_pl_fc'
  Fc = 1,0

fun Pvar 'Tex_f1_pl_pvar'
  Pvar(i) = 2,i

fun Not 'Tex_f1_pl_not'
  Not(a) = 3,a

fun/2 And 'Tex_f2_pl_and'
  And(a,b) = 4,a,b

fun/2 Or 'Tex_f2_pl_or'
  Or(a,b) = 5,a,b

fun/2 Imp 'Tex_f2_pl_imp'
  Imp(a,b) = 6,a,b

fun/2 Iff 'Tex_f2_pl_iff'
  Iff(a,b) = 7,a,b

rem 
  \para \bf  [CL] Discrimination on the constructors of propositional formulas. 
   \end Example(s): 
  \def 
    fun F 'Tex_f1_f'
    F(Tc) = Foo
    F(Fc) = Foo
    F Pvar(i) = Foo
    F Not(a) = Foo
    F And(a,b) = Foo
    F Or(a,b) = Foo
    F Imp(a,b) = Foo
    F Iff(a,b) = Foo
  \end

rem 
  \para \bf  Propositional formulas.  \end 

pred Form 
  Form(Tc)
  Form(Fc)
  Form Pvar(i) <- N(i)
  Form Not(a) <- Form(a)
  Form And(a,b) <- Form(a) & Form(b)
  Form Or(a,b) <- Form(a) & Form(b)
  Form Imp(a,b) <- Form(a) & Form(b)
  Form Iff(a,b) <- Form(a) & Form(b)

rem 
  \para \it  List of propositional formulas.  \end 

pred Forml 'Tex_f1_pl_forml'
  Forml(0)
  Forml(a,as) <- Form(a) & Forml(as)

rem 
  \para \it  List of propositional variables.  \end 

pred Pvarl 'Tex_f1_pl_pvarl'
  Pvarl(as) <-> \a a(a in as -> \e i a = Pvar(i))

rem 
  \para \bf  [CL] Formatting the output.  \end Use the format \ft Form \end to 
  display numbers as propositional formulas. Try out the following simple 
  queries 
  \verbatim 
     97563929 = t:Form
  \end
  \verbatim 
     3,4,(2,1),2,2 = t:Form
  \end
  \para Use the format \ft Forml \end to display numbers as lists of 
  propositional formulas. 

rem 
  \para \bf  Subsection. Basic Operations and Predicates.  \end 

rem 
  \para \bf  Propositional size.  \end \header* fun Sz 'Tex_f1_pl_sz' \end 
  Define the function \ft Sz(a) \end computing the size of the propositional 
  formula \ft a \end. 

fun Sz 'Tex_f1_pl_sz'
  Sz(a) = Foo

fun Szl 'Tex_f1_pl_szl'
  Szl(0) = 0
  Szl(a,as) = Sz(a)+Szl(as)

rem 
  \para \bf  Truth predicate.  \end \header* pred/2 True 'Tex_p2_pl_true' \end 
  Define the predicate \ft True(v,a) \end such that 
  \eq* 
    True(v,Tc)
  \end
  \eq* 
    ~True(v,Fc)
  \end
  \eq* 
    True(v,Pvar(i)) <-> i in v
  \end
  \eq* 
    True(v,Not(a)) <-> ~True(v,a)
  \end
  \eq* 
    True(v,And(a,b)) <-> True(v,a) & True(v,b)
  \end
  \eq* 
    True(v,Or(a,b)) <-> True(v,a) \/ True(v,b)
  \end
  \eq* 
    True(v,Imp(a,b)) <-> True(v,a) -> True(v,b)
  \end
  \eq* 
    True(v,Iff(a,b)) <-> True(v,a) <-> True(v,b)
  \end

pred/2 True 'Tex_p2_pl_true'
  True(v,a) <-> Poo

rem 
  \para \bf  Tautologies.  \end 

pred Taut 'Tex_p1_pl_taut'
  Taut(a) <-> \a vTrue(v,a)

rem 
  \para \bf  Generalized connectives.  \end 
  \header* fun Andl 'Tex_f1_pl_andl' \end \header* fun Orl 'Tex_f1_pl_orl' \end 
  Define the functions \ft Andl(as) \end and \ft Orl(as) \end such that 
  \eq* 
    Forml(as) -> Form Andl(as)
  \end
  \eq* 
    True(v,Andl(as)) <-> \a a(a in as -> True(v,a))
  \end
  \para and 
  \eq* 
    Forml(as) -> Form Orl(as)
  \end
  \eq* 
    True(v,Orl(as)) <-> \e a(a in as & True(v,a))
  \end

fun Andl 'Tex_f1_pl_andl'
  Andl(as) = Foo

fun Orl 'Tex_f1_pl_orl'
  Orl(as) = Foo

rem 
  \para \bf  Propositional sequents.  \end 

pred/2 Tautsq 'Tex_p2_pl_tautsq'
  Tautsq(as,bs) <-> Taut Imp(Andl(as),Orl(bs))

rem 
  \para \bf  Subsection. Tautology Checker.  \end 

rem 
  \para \bf  Tautology checker for atomic propositional sequents.  \end 
  \header* pred/2 Closes  \end Define the predicate \ft Closes(as,bs) \end such 
  that 
  \eq* 
    Pvarl(as) & Pvarl(bs) -> Closes(as,bs) <-> Tautsq(as,bs)
  \end
  \para \it  Hint.  \end The definition is based on the following property 
  \eq* 
    Pvarl(as) & Pvarl(bs) -> Tautsq(as,bs) <-> 
    \e i(Pvar(i) in as & Pvar(i) in bs)
  \end

pred/2 Closes 
  Closes(as,bs) <-> Poo

rem 
  \para \bf  Auxiliary predicate.  \end 
  \header* pred/4 Prfsq1 'Tex_p4_pl_prfsq1' \end Define the predicate 
  \ft Prfsq1(as,bs,cs,ds) \end such that 
  \eq* 
    Forml(as) & Pvarl(bs) & Forml(cs) & Pvarl(ds) -> Prfsq1(as,bs,cs,ds) <-> 
    Tautsq(as++bs,cs++ds)
  \end
  \para \it  Remark.  \end Note that the definition is regular in the measure 
  \ft Szl(as)+Szl(cs) \end. 

pred/4 Prfsq1 'Tex_p4_pl_prfsq1'
  Prfsq1(as,bs,cs,ds) <-> Poo

rem 
  \para \bf  Tautology checker for propositional sequents.  \end 
  \header* pred/2 Prfsq 'Tex_p2_pl_prfsq' \end Define the predicate 
  \ft Prfsq(as,bs) \end such that 
  \eq* 
    Forml(as) & Forml(bs) -> Prfsq(as,bs) <-> Tautsq(as,bs)
  \end

pred/2 Prfsq 'Tex_p2_pl_prfsq'
  Prfsq(as,bs) <-> Poo

rem 
  \para \bf  Tautology checker.  \end \header* pred Prf 'Tex_p1_pl_prf' \end 
  Define the predicate \ft Prf(a) \end such that 
  \eq* 
    Form(a) -> Prf(a) <-> Taut(a)
  \end

pred Prf 'Tex_p1_pl_prf'
  Prf(a) <-> Poo

rem 
  \para \bf  Examples.  \end The following formulas are tautologies: 

fun/0 A1 
  A1 = Imp(Pvar(1),Imp(Pvar(2),Pvar(1)))

fun/0 A2 
  A2 = Imp(And(Imp(Pvar(1),Pvar(2)),Imp(Pvar(2),Pvar(3))),Imp(Pvar(1),Pvar(3)))

fun/0 A3 
  A3 = 
  Imp(And(And(Imp(Pvar(1),Pvar(3)),Imp(Pvar(2),Pvar(3))),Or(Pvar(1),Pvar(2))),
      Pvar(3))

fun/0 A4 
  A4 = Iff(Not Imp(Pvar(1),Pvar(2)),And(Pvar(1),Not Pvar(2)))

fun/0 A5 
  A5 = 
  Iff(Or(Pvar(1),And(Pvar(2),Pvar(3))),
      And(Or(Pvar(1),Pvar(2)),Or(Pvar(1),Pvar(3))))

rem 
  \para and the following are not: 

fun/0 B1 
  B1 = 
  Imp(Imp(And(Pvar(1),Pvar(2)),Pvar(3)),
      And(Imp(Pvar(1),Pvar(3)),Imp(Pvar(2),Pvar(3))))

fun/0 B2 
  B2 = Imp(Or(Pvar(1),Pvar(2)),And(Pvar(1),Pvar(2)))

fun/0 B3 
  B3 = Imp(Imp(Pvar(1),Pvar(2)),Imp(Not Pvar(1),Not Pvar(2)))

